#ifndef GGAF_DX_VECDRIVERMVASSISTANT_H_
#define GGAF_DX_VECDRIVERMVASSISTANT_H_
#include "GgafDxCommonHeader.h"
#include "jp/ggaf/core/Object.h"
#include "jp/ggaf/core/util/AccelerationValue.hpp"

namespace GgafDx {

/**
 * ͎Ԃ̏A .
 * t(͎)̈ړx̕⍲s܂B
 * @version 1.00
 * @since 2013/12/05
 * @author Masatoshi Tsuge
 */
class VecDriverMvAssistant : public GgafCore::Object {
	friend class VecDriver;

private:
    /** [r]t */
    VecDriver* const _pMaster;
    GgafCore::AccelerationValue<int> _smthMv;

    /**
     * ͎Ԃ̏肪U镑 .
     * tU镑(behave())ɁAŌĂяôŋCɂȂł悢łB
     */
    virtual void behave();

public:
    /**
     * RXgN^<BR>
     * @param   prm_pMaster  t
     */
    explicit VecDriverMvAssistant(VecDriver* prm_pMaster);


    /**
     * Ȃ߂炩ȈړxωV[NGXs(ԁEwAxϓ) .
     * ړɔ₳鎞(Te)3̃ZNVɕÂ悤ȑxIɍsB<BR>
     * E 0     `  p1*Te ܂ EEE ݂̑xgbvXs[h܂ŉ(or)ړ<BR>
     * E p1*Te `  p2*Te ܂ EEE gbvXs[hœړ<BR>
     * E p2*Te `  Te    ܂ EEE gbvXs[hŏIXs[h֌(or)ړ<BR>
     * }Q<BR>
     * <pre>
     *
     *    x(v)
     *     ^
     *     |
     *     |                         V0:_̑x
     *     |                         Ve:ŏIx
     *     |                          D:ڕWړ
     *   Vt|....___________          Te:ڕWԁit[j
     *     |   /:         :_        p1:gbvXs[hɒB鎞ƂȂ悤ȁATeɑ΂銄(0.0`1.0)
     *   Ve|../.:.........:.._      p2:JnƂȂ悤ȁATeɑ΂銄(0.0`1.0)
     *     | /  :         :    |     Vt:EԂ瓱gbvXs[h
     *     |/   :         :    |
     *   V0|    :    D    :    |
     *     |    :         :    |
     *   --+----+---------+----+-----> (t:t[)
     *   0 |  p1*Te     p2*Te  Te
     *
     * </pre>
     * ŏIXs[h(Ve)AڕWړ(D)ABڕW(Te)Ay p1, p2 w肷B<BR>
     * gbvXs[h(Vt)͓ŎvZ肳B<BR>
     * @param prm_target_distance ڕWړ(D)
     * @param prm_target_frames ₷(Te)(t[wA͕̐s)
     * @param prm_p1 gbvXs[hɒB鎞ƂȂ悤ȁATeɑ΂銄(p1)
     * @param prm_p2 JnƂȂ悤ȁATeɑ΂銄(p2)
     * @param prm_end_velo ŏIXs[h(Ve)
     * @param prm_zero_acc_end_flg true:ڕWړɒBۂɉxOɋݒ/false:x͂̂܂܂ɂĂ
     */
    void slideByDt(coord prm_target_distance, int prm_target_frames,
                   float prm_p1, float prm_p2, velo prm_end_velo,
                   bool prm_zero_acc_end_flg);

    /**
     * Ȃ߂炩ȈړxωV[NGXs(xEwAԕϓ) .
     * ړ3̃ZNV(d1,d2,d3)ɕÂ悤ȑxIɍsB<BR>
     * E 0     `  d1       ܂ EEE ݂̑xgbvXs[h܂ŉ(or)ړ<BR>
     * E d1    `  d1+d2    ܂ EEE gbvXs[hœړ<BR>
     * E d1+d2 `  d1+d2+d3 ܂ EEE gbvXs[hŏIXs[h֌(or)ړ<BR>
     * }Q<BR>
     * <pre>
     *    x(v)
     *     ^
     *     |                         V0:_̑x
     *     |                         Vt:gbvXs[h
     *     |                         Ve:ŏIx
     *     |         D=d1+d2+d3       D:ڕWړ(D=d1+d2+d3)
     *   Vt|....___________          p1:gbvXs[hɒB鋗ƂȂ悤ȁA(D)ɑ΂銄
     *     |   /|         |_            ܂    d1 = D*p1 ƂȂ悤 p1 (0.0`1.0)
     *   Ve|../.|.........|.._      p2:JnƂȂ悤ȁA(D)ɑ΂銄
     *     | /  |         |    |         ܂ d1+d2 = D*p2 ƂȂ悤 p2 (0.0`1.0)
     *     |/   |         |    |     Te:₳Kvԁit[j
     *   V0| d1 |    d2   | d3 |
     *     |    |         |    |
     *   --+----+---------+----+-----> (t:t[)
     *   0 |                  Te
     *
     * </pre>
     * gbvXs[h(Vt)AŏIXs[h(Ve)AڕWړ(D)Ay p1, p2 w肷B<BR>
     * ₳鎞(Te)͓Ŏv肳B<BR>
     * <BR>
     * @param prm_top_velo gbvXs[h(Vt) (>=0)
     * @param prm_target_distance ڕWړ(D)
     * @param prm_p1 gbvXs[hɒB鋗ƂȂ悤ȁA(D)ɑ΂銄B(d1 = D*prm_p1)
     * @param prm_p2 JnƂȂ悤ȁA(D)ɑ΂銄 (d1+d2 = D*p2)
     * @param prm_end_velo ŏIXs[h(Ve) (>=0)
     * @param prm_zero_acc_end_flg true:ڕWԂɒBۂɉxOɋݒ/false:x͂̂܂܂ɂĂ
     */
    void slideByVd(velo prm_top_velo, coord prm_target_distance,
                   float prm_p1, float prm_p2, velo prm_end_velo,
                   bool prm_zero_acc_end_flg);

    bool isSliding() {
        return _smthMv.isAccelerating();
    }

    void stopSliding() {
        _smthMv.stopAccelerating();
    }

    bool hasJustFinishedSliding() {
        return _smthMv.hasJustFinishedAccelerating();
    }

    virtual ~VecDriverMvAssistant();
};

}
#endif /*GGAF_DX_VECDRIVERMVASSISTANT_H_*/

