#ifndef GGAF_DX_POINTSPRITEMODEL_H_
#define GGAF_DX_POINTSPRITEMODEL_H_
#include "GgafDxCommonHeader.h"
#include "jp/ggaf/dx/model/Model.h"

namespace GgafDx {

/**
 * PointSpriteActorpfNX.
 * @version 1.00
 * @since 2008/02/22
 * @author Masatoshi Tsuge
 */
class PointSpriteModel : public Model {
    friend class ModelManager;

public:
    struct VERTEX {
        float x, y, z;    // _W
        float psize;      // |CgTCY
        DWORD color;      // _̐F
        float tu, tv;     // eNX`W
    };

    /** _obt@ */
    LPDIRECT3DVERTEXBUFFER9 _pVertexBuffer;
    /** _z */
    VERTEX* _paVtxBuffer_data;
    /** _(=XvCg) */
    int _vertices_num;
    /** _FVF */
    static DWORD FVF;
    /** `̒_ṽTCY */
    UINT _size_vertices;
    /** 1_̃TCY */
    UINT _size_vertex_unit;
    /** IuWFNĝPӂ̃TCY(px) */
    float _square_size_px;
    /** eNX`̂Pӂ̒(px) */
    float _texture_size_px;
    /** eNX`(PŕBQłSp^[ARłXp^[) */
    int _texture_split_rowcol;
    float _inv_texture_split_rowcol;
public:
    /**
     * RXgN^<BR>
     * @param prm_model_name XvCg`̎ʖB".psprx"ǉƒ`Xt@CɂȂB
     */
    PointSpriteModel(const char* prm_model_name);

    virtual HRESULT draw(FigureActor* prm_pActor_target, int prm_draw_set_num = 1, void* prm_pPrm = nullptr) override;

    virtual void restore() override;

    virtual void onDeviceLost() override;

    void release() override;

    /**
     * fXgN^<BR>
     */
    virtual ~PointSpriteModel(); //fXgN^
};

}
#endif /*GGAF_DX_POINTSPRITEMODEL_H_*/
