#include "jp/ggaf/dx/util/curve/FixedVelocityCurveManufacture.h"

#include "jp/ggaf/dx/util/curve/CurveSource.h"
#include "jp/ggaf/dx/util/curve/FixedVelocityCurveVecDriverLeader.h"

using namespace GgafDx;

FixedVelocityCurveManufacture::FixedVelocityCurveManufacture(const char* prm_coord_spl_file,
                                                             angvelo prm_angvelo_rzry_mv,
                                                             int prm_turn_way,
                                                             bool prm_turn_optimaize) :
        CurveManufacture(prm_coord_spl_file) {
    _angvelo_rzry_mv = prm_angvelo_rzry_mv;
    _turn_way = prm_turn_way;
    _turn_optimize = prm_turn_optimaize;
    _velo_mvUnit = PX_C(1); //x PX_C(1) Ƃꍇ̊eԂ̃t[{Ƃ
    _paFrame_need_at = NEW float[_pCurve->_rnum];
    _move_method = FixedVelocity;
}

FixedVelocityCurveManufacture::FixedVelocityCurveManufacture(CurveSource* prm_pCurve,
                                                             angvelo prm_angvelo_rzry_mv,
                                                             int prm_turn_way,
                                                             bool prm_turn_optimaize) :
        CurveManufacture(prm_pCurve) {
    _angvelo_rzry_mv = prm_angvelo_rzry_mv;
    _turn_way = prm_turn_way;
    _turn_optimize = prm_turn_optimaize;
    _velo_mvUnit = PX_C(1); //x PX_C(1) Ƃꍇ̊eԂ̃t[{Ƃ
    _paFrame_need_at = NEW float[_pCurve->_rnum];
    _move_method = FixedVelocity;
}

void FixedVelocityCurveManufacture::calculate() {
    //̂Q̃e[uČvZXV܂B
    // _paDistance_to[] : ݂̕⊮_A̕⊮_܂ł̋
    // _paFrame_need_at[] : n_⊮_BɕKvȃt[̔z

    //e_̎_́AƕKvȃt[\ߑS߂Ă
    // _[2][3] = { {1000,2000,3000}, {2000,1000,0}, {3900, 0, 1000} }
    // point_num = 3          //_̐
    // accuracy = 0.25(=1/4)  //⊮_x
    //
    // ̏ꍇA}̂悤ɂȂ܂B
    //
    // X:_
    // o:_Ԃ̕⊮_iXvCȐʉߓ_j
    // X--o: ړ\̍W
    // _paDistance_to[] : ݂̕⊮_A̕⊮_܂ł̋
    // _paFrame_need_at[] : n_⊮_BɕKvȃt[̔z
    //
    // sp._rnum ͍v̓_̐ԂB sp._rnum = 9 ɂȂB
    // prm_accuracy YȕɂȂȂꍇA_ɕ⊮_J邩ƂASR킩Ȃ̂ŁAsp._rnumKgp
    // }YɏdȂꍇ̐}łB
    //
    //                             _velo_mvUnit = 1000
    //
    //               _paFrame_need_at[1] Kvȃt[
    //                     ||              _paFrame_need_at[5]
    //                   <--->                      ||                 _paFrame_need_at[8]
    //                   <----------------------------->                      ||
    //                   <------------------------------------------------------->
    //
    //              _paDistance_to[1]      _paDistance_to[5]         _paDistance_to[8]
    //                    ||                     ||                         ||
    //                   <--->                <------->                  <------->
    //                  X----o----o----o-----X--------o---------o--------o-------X
    //                  ^                    ^        ^                          ^
    //                  |                    |        |                          |
    //            (sp._x_compute[0],         | (sp._x_compute[5],        sp._x_compute[8]
    //             sp._y_compute[0],         |  sp._y_compute[5],        sp._y_compute[8]
    //             sp._z_compute[0])         |  sp._z_compute[5])        sp._z_compute[8]
    //                  |                    |                                   |
    //            (_[0][0],           (_[1][0],                   (_[2][0],
    //             _[0][1],            _[1][1],                    _[2][1],
    //             _[0][2])            _[1][2])                    _[2][2])
    //              = (1000,2000,3000)    = (2000,1000,0)                   = (3900, 0, 1000)
    //
    //                 <--------------------------------------------------------->
    //                          veloMoveUnit ̑xňړƂꍇvZ
    //
    CurveManufacture::calculate();
    _paFrame_need_at[0] = 0; //n_ɍs܂łɕKvȃt[͕s
    int rnum = _pCurve->_rnum;
    for (int t = 1; t < rnum; t ++) {
        // paDistanceTo[t] Ax _velo_mvUnit(=1000) ňړ̂ɕKvȃt[߂B
        //ԁ
        _paFrame_need_at[t] = _paFrame_need_at[t-1] + (float)(1.0*_paDistance_to[t] / _velo_mvUnit);
    }
}

DriverLeader* FixedVelocityCurveManufacture::createVecDriverLeader(GgafDx::VecDriver* prm_pVecDriver) {
    return NEW FixedVelocityCurveVecDriverLeader(this, prm_pVecDriver);
}

FixedVelocityCurveManufacture::~FixedVelocityCurveManufacture() {
    GGAF_DELETEARR_NULLABLE(_paDistance_to);
    GGAF_DELETEARR_NULLABLE(_paFrame_need_at);
}
