#include "GgafEffectConst.fxh"
////////////////////////////////////////////////////////////////////////////////
// ggaf CuAGgafDx::BoardModelpVF[_[
//yTvz
// D3DFVF_XYZRHW ŕ`悵悤ȎdlłQc\܂B
// ʍ(0,0)ŉʉEiʕ(px), ʍ(px))ƂȂWn
// v~eBui|j̊_͍ɂȂ܂B
// author : Masatoshi Tsuge
// date:2009/03/06
////////////////////////////////////////////////////////////////////////////////
float4 g_colMaterialDiffuse;
float g_offset_u; //eNX`UW
float g_offset_v; //eNX`VW
float g_transformed_x; //ACglAϊςXW(px)
float g_transformed_y; //ACglAϊςYW(px)
float g_local_left_top_x;  //[JϊςXW(px)
float g_local_left_top_y;  //[JϊςYW(px)
float g_depth_z; //[xZ (0 ` +1)
float g_game_buffer_width; //ʕ(px)
float g_game_buffer_height; //ʍ(px)
float g_inv_game_buffer_width; //ʕ(px)̋t
float g_inv_game_buffer_height; //ʍ(px)̋t
float g_sx; //Xg嗦(1.0œ{)
float g_sy; //Yg嗦(1.0œ{)
float g_rz; //Z]piWAj0`2
float g_tex_blink_power;
float g_tex_blink_threshold;
float g_alpha_master;
//s0WX^̃Tvg(ŒpCvCɃZbgꂽeNX`VF[_[Ŏg)
sampler MyTextureSampler : register(s0);

//_VF[_[Ao͍\
struct OUT_VS
{
    float4 posModel_Proj : POSITION;
    float2 uv            : TEXCOORD0;
};


///////////////////////////////////////////////////////////////////////////

//BoardModelW_VF[_[
OUT_VS VS_DefaultBoard(
      float4 prm_posModel_Local : POSITION,  // f̒_
      float2 prm_uv             : TEXCOORD0  // f̒_UV
) {
    OUT_VS out_vs = (OUT_VS)0;
    if (g_rz == 0.0f) {
        //XWYW -1 ` +1 ɉ߂B
        out_vs.posModel_Proj.x = - 1 + ( (2*( ((prm_posModel_Local.x + g_local_left_top_x)*g_sx) + g_transformed_x) ) * g_inv_game_buffer_width);
        out_vs.posModel_Proj.y =   1 - ( (2*( ((prm_posModel_Local.y + g_local_left_top_y)*g_sy) + g_transformed_y) ) * g_inv_game_buffer_height);
    } else {
        //gk
        const float lx = (prm_posModel_Local.x + g_local_left_top_x) * g_sx;
        const float ly = (prm_posModel_Local.y + g_local_left_top_y) * g_sy;
        //]  XWYW -1 ` +1 ɉ߂B
        out_vs.posModel_Proj.x = - 1 + ( (2*( (lx * cos(g_rz) - ly * sin(g_rz))                  + g_transformed_x) ) * g_inv_game_buffer_width);
        out_vs.posModel_Proj.y =   1 - ( (2*( (lx * sin(g_rz) + ly * cos(g_rz))                  + g_transformed_y) ) * g_inv_game_buffer_height);
    }
    out_vs.posModel_Proj.z = g_depth_z;
    out_vs.posModel_Proj.w = 1.0;
    //dot by dotl
    out_vs.posModel_Proj = adjustDotByDot(out_vs.posModel_Proj);

    //UṼItZbgZ
    out_vs.uv.x = prm_uv.x + g_offset_u;
    out_vs.uv.y = prm_uv.y + g_offset_v;

    return out_vs;
}


float4 PS_DefaultBoard(
    float2 prm_uv      : TEXCOORD0
) : COLOR  {
    float4 colOut = tex2D( MyTextureSampler, prm_uv);
    if (colOut.r >= g_tex_blink_threshold || colOut.g >= g_tex_blink_threshold || colOut.b >= g_tex_blink_threshold) {
        colOut *= g_tex_blink_power; //+ (colTex * g_tex_blink_power);
    }
    colOut *= g_colMaterialDiffuse;
    colOut.a *= g_alpha_master;
    return colOut;
}

float4 PS_Flush(
    float2 prm_uv      : TEXCOORD0
) : COLOR  {
    //eNX`TvOĐF擾iF擾j
    float4 colOut = tex2D( MyTextureSampler, prm_uv) * FLUSH_COLOR;
    colOut *= g_colMaterialDiffuse;
    colOut.a *= g_alpha_master;
    return colOut;
}

//eNjbNFDefaultBoardTechnique
//BoardModelpWVF[_[
technique DefaultBoardTechnique
{
    pass P0 {
        AlphaBlendEnable = true;
        SeparateAlphaBlendEnable = false;
        SrcBlend  = SrcAlpha;
        DestBlend = InvSrcAlpha;
        BlendOp = Add;
        VertexShader = compile VS_VERSION VS_DefaultBoard();
        PixelShader  = compile PS_VERSION PS_DefaultBoard();
    }
}

technique DestBlendOne
{
    pass P0 {
        AlphaBlendEnable = true;
        SeparateAlphaBlendEnable = false;
        SrcBlend  = SrcAlpha;
        DestBlend = One; //Z
        BlendOp = Add;
        VertexShader = compile VS_VERSION VS_DefaultBoard();
        PixelShader  = compile PS_VERSION PS_DefaultBoard();
    }
}

technique Flush
{
    pass P0 {
        AlphaBlendEnable = true;
        SeparateAlphaBlendEnable = false;
        SrcBlend  = SrcAlpha;
        DestBlend = InvSrcAlpha;
        BlendOp = Add;
        VertexShader = compile VS_VERSION VS_DefaultBoard();
        PixelShader  = compile PS_VERSION PS_Flush();
    }
}
