#include "EnemyErmioneArm.h"
#include "EnemyErmione.h"

#include "jp/ggaf/dx/actor/GeometricActor.h"
#include "jp/ggaf/dx/actor/supporter/SeTransmitterForActor.h"
#include "jp/ggaf/dx/actor/supporter/VecDriver.h"
#include "jp/gecchi/VioletVreath/God.h"
#include "jp/gecchi/VioletVreath/util/MyStgUtil.h"
#include "jp/gecchi/VioletVreath/scene/Spacetime/World/GameScene/MyShipScene.h"
#include "jp/ggaf/dx/actor/supporter/VecDriverFaceAngAssistant.h"
#include "jp/gecchi/VioletVreath/actor/effect/Blink/EffectBlink.h"

using namespace GgafLib;
using namespace VioletVreath;

EnemyErmioneArm::EnemyErmioneArm(const char* prm_name, const char* prm_model, void* prm_pFuncStatusReset) :
        VvEnemyActor<DefaultMeshSetActor>(prm_name, prm_model, prm_pFuncStatusReset) {
    _class_name = "EnemyErmioneArm";

    aiming_ang_velo_ = 0;
    aiming_movable_limit_ang_ = 0;
    GgafDx::SeTransmitterForActor* pSeTx = getSeTransmitter();
    pSeTx->set(SE_DAMAGED  , "WAVE_ENEMY_DAMAGED_001");
    pSeTx->set(SE_EXPLOSION, "WAVE_EXPLOSION_001"); //rj
    behave_frames_ = 0;
    arm_no_ = 0;
    arm_part_no_ = 0;
}


void EnemyErmioneArm::initialize() {
}

void EnemyErmioneArm::onActive() {
    getStatus()->reset();
    getProgress()->reset(PROG_INIT);
}

void EnemyErmioneArm::processBehavior() {

    changeGeoLocal(); //[JW̑ƂB
    GgafDx::VecDriver* const pVecDriver = getVecDriver();
    GgafCore::Progress* const pProg = getProgress();
    switch (pProg->get()) {
        case PROG_INIT: {
            pProg->change(PROG_WAITING);
            break;
        }
        case PROG_WAITING: {
            if (pProg->hasJustChanged()) {
                //{̂FKƂĒǉꂽ́AxprocessSettlementBehavior()sȂ
                //WfȂAāBPt[PROG_WAITINGŃGgGtFss
                UTIL::activateEntryEffectOf(this);
            }
            break;
        }

        case PROG_NOTHING: {
            if (pProg->hasJustChanged() ) {
                behave_frames_ = RND(1, 10);
            }
            if (pProg->hasArrivedAt(behave_frames_)) {
                pProg->change(PROG_AIMING);
            }
            break;
        }

        case PROG_AIMING: {
            if (pProg->hasJustChanged() ) {
                if (aiming_movable_limit_ang_ > 0) {
                    //@֕
                    //lF[JWnŗ\߂ǂ̕ɌĂ΁AŏIIɎ@ɌƂɂȂ邩߂
                    //
                    //@ւ̌߂̕ϊOԂŁA
                    //[JWŁuĂ΂̂ł͂Ȃṽ̕xNg(tvx, tvy, tvz) ƂA
                    //uy܂Łv̍s̐ρi_pActor_base->_matWorldRotMv)  b_mat_xx ƂB
                    //݂̍ŏIW玩@ւ̌̃xNgA(mvx, mvy, mvz) ƂƁA
                    //
                    // | b_mat_11 b_mat_12 b_mat_13 | |tvx|   |mvx|
                    // | b_mat_21 b_mat_22 b_mat_23 | |tvy| = |mvy|
                    // | b_mat_31 b_mat_32 b_mat_33 | |tvz|   |mvz|
                    //
                    //ƂȂ͂B(tvx, tvy, tvz)ɂĉBts|ċ߂ΗǂB
                    //
                    // |tvx|   | b_mat_11 b_mat_12 b_mat_13 | -1  |mvx|
                    // |tvy| = | b_mat_21 b_mat_22 b_mat_23 |     |mvy|
                    // |tvz|   | b_mat_31 b_mat_32 b_mat_33 |     |mvz|
                    //
                    //mvx mvy mvz ́A@ւ̕xNgł
                    int mvx,mvy,mvz;
                    if (RND(1, 1000) < 960 || arm_part_no_ >= 9) {
                        //΍WnŒʏ̎@_xNg
                        GgafDx::GeometricActor* pTargetActor = pMYSHIP;
                        mvx = pTargetActor->_x - _x_final; //Ŏg _x, _y, _z ͐΍W(_x_final)ł邱Ƃ|Cg
                        mvy = (pTargetActor->_y + PX_C(50)) - _y_final; //@̂_
                        mvz = pTargetActor->_z - _z_final;
                    } else {
                        //܁`ɋtڕWɂāAGɓv
                        GgafDx::GeometricActor* pTargetActor = pMYSHIP;
                        mvx = _x_final - pTargetActor->_x;
                        mvy = _y_final - pTargetActor->_y;
                        mvz = _z_final - pTargetActor->_z;
                    }
                    //ts擾
                    D3DXMATRIX* pBaseInvMatRM = getBaseActor()->getInvMatWorldRotMv();
                    //[JWł̃^[QbgƂȂxNgvZ
                    int tvx = mvx*pBaseInvMatRM->_11 + mvy*pBaseInvMatRM->_21 + mvz*pBaseInvMatRM->_31;
                    int tvy = mvx*pBaseInvMatRM->_12 + mvy*pBaseInvMatRM->_22 + mvz*pBaseInvMatRM->_32;
                    int tvz = mvx*pBaseInvMatRM->_13 + mvy*pBaseInvMatRM->_23 + mvz*pBaseInvMatRM->_33;
                    //V[NGXJn
                    angle rz_target, ry_target;
                    UTIL::convVectorToRzRy(tvx, tvy, tvz, rz_target, ry_target);
                    //vŽʁArz_target ry_target Ɍ΁A@Ɍ

                    //rz_targetAry_target ͈͓ɐ
                    if (aiming_movable_limit_ang_ <= rz_target && rz_target <= D180ANG) {
                        rz_target = aiming_movable_limit_ang_;
                    } else if (D180ANG <= rz_target && rz_target <= D360ANG - aiming_movable_limit_ang_) {
                        rz_target = D360ANG - aiming_movable_limit_ang_;
                    }
                    if (aiming_movable_limit_ang_ <= ry_target && ry_target <= D180ANG) {
                        ry_target = aiming_movable_limit_ang_;
                    } else if (D180ANG <= ry_target && ry_target <= D360ANG - aiming_movable_limit_ang_) {
                        ry_target = D360ANG - aiming_movable_limit_ang_;
                    }

                    pVecDriver->turnRzRyFaceAngTo(
                                    rz_target, ry_target,
                                    aiming_ang_velo_, aiming_ang_velo_*0.01,
                                    TURN_CLOSE_TO, false);
                }
            }
            if (pVecDriver->isTurningFaceAng()) {
                // ҋ@
            } else {
                pProg->change(PROG_NOTHING);
            }

            break;
        }

        default :
            break;
    }

    pVecDriver->behave();
    changeGeoFinal();
    //pScaler_->behave();
    if (_pActor_base) {
        setAlpha(((GgafDx::FigureActor*)_pActor_base)->getAlpha());
    }
}

void EnemyErmioneArm::processJudgement() {
    if (getBaseActor() && getBaseActor()->isActiveInTheTree()) {
    } else {
        //y䂪ȂΎ
        sayonara();
    }
}


void EnemyErmioneArm::onInactive() {
    sayonara();
}

void EnemyErmioneArm::onCatchEvent(hashval prm_no, void* prm_pSource) {
    if ( prm_no == EVENT_ERMIONE_SAYONARA) {
        //{̔j
        setHitAble(false);
        UTIL::activateExplosionEffectOf(this);//GtF
        sayonara();
    }
    if ( prm_no == EVENT_ERMIONE_ENTRY_DONE) {
        setHitAble(true);
        getProgress()->change(PROG_NOTHING);
    }
}

EnemyErmioneArm::~EnemyErmioneArm() {
}
